commit 7a51946e00fa2fb2ffacdd7c8d0a80e056c1f7ff
Author: H.J. Lu <hjl.tools@gmail.com>
Date:   Fri Oct 4 16:21:15 2024 +0800

    x86: Disable stack protector for naked functions
    
    Since naked functions should not enable stack protector, define
    TARGET_STACK_PROTECT_RUNTIME_ENABLED_P to disable stack protector
    for naked functions.
    
    gcc/
    
            PR target/116962
            * config/i386/i386.cc (ix86_stack_protect_runtime_enabled_p): New
            function.
            (TARGET_STACK_PROTECT_RUNTIME_ENABLED_P): New.
    
    gcc/testsuite/
    
            PR target/116962
            * gcc.target/i386/pr116962.c: New file.
    
    Signed-off-by: H.J. Lu <hjl.tools@gmail.com>
    (cherry picked from commit 7d2845da112214f064e7b24531cc67e256b5177e)

diff --git a/gcc/config/i386/i386.cc b/gcc/config/i386/i386.cc
index 882de00610f..2087f8633eb 100644
--- a/gcc/config/i386/i386.cc
+++ b/gcc/config/i386/i386.cc
@@ -22644,6 +22644,13 @@ ix86_stack_protect_guard (void)
   return default_stack_protect_guard ();
 }
 
+static bool
+ix86_stack_protect_runtime_enabled_p (void)
+{
+  /* Naked functions should not enable stack protector.  */
+  return !ix86_function_naked (current_function_decl);
+}
+
 /* For 32-bit code we can save PIC register setup by using
    __stack_chk_fail_local hidden function instead of calling
    __stack_chk_fail directly.  64-bit code doesn't need to setup any PIC
@@ -24650,6 +24657,10 @@ ix86_libgcc_floating_mode_supported_p
 #undef TARGET_STACK_PROTECT_GUARD
 #define TARGET_STACK_PROTECT_GUARD ix86_stack_protect_guard
 
+#undef TARGET_STACK_PROTECT_RUNTIME_ENABLED_P
+#define TARGET_STACK_PROTECT_RUNTIME_ENABLED_P \
+  ix86_stack_protect_runtime_enabled_p
+
 #if !TARGET_MACHO
 #undef TARGET_STACK_PROTECT_FAIL
 #define TARGET_STACK_PROTECT_FAIL ix86_stack_protect_fail
diff --git a/gcc/testsuite/gcc.target/i386/pr116962.c b/gcc/testsuite/gcc.target/i386/pr116962.c
new file mode 100644
index 00000000000..ced16eee746
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr116962.c
@@ -0,0 +1,10 @@
+/* { dg-do compile { target fstack_protector } } */
+/* { dg-options "-O2 -fstack-protector-all" } */
+/* { dg-final { scan-assembler-not "__stack_chk_fail" } } */
+
+__attribute__ ((naked))
+void
+foo (void)
+{
+  asm ("ret");
+}

